<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/29/2006 *
 * ================                             Last change: 01/29/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_cache.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for the caching system             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration des Caching-Systems                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (isset($_POST['ok'])) {
	// Cache path has been not changed by default so don't test it again
	$_POST['cache_tested'] = "N";

	// Check if path has been changed
	if ($_POST['cache_path'] != getConfig('cache_path')) {
		// Okay, cache path has been altered so we have to test it again!
		$_POST['cache_tested'] = "Y";
	}

	// Delete deactivated cache files
	if (($_POST['cache_admins'] == "N") && ($cacheInstance->loadCacheFile("admins"))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_acls'] == "N") && ($cacheInstance->loadCacheFile("acls"))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_exts'] == "N") && ($cacheInstance->loadCacheFile("extensions", true))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_config'] == "N") && ($cacheInstance->loadCacheFile("config"))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_modreg'] == "N") && ($cacheInstance->loadCacheFile("modreg"))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_refdepth'] == "N") && ($cacheInstance->loadCacheFile("refdepth"))) {
		$cacheInstance->destroyCacheFile();
	}
	if (($_POST['cache_refsys'] == "N") && ($cacheInstance->loadCacheFile("refsys"))) {
		$cacheInstance->destroyCacheFile();
	}

	// Save configuration
	ADMIN_SAVE_SETTINGS($_POST);
} else {
	// Prepare data
	switch (getConfig('cache_admins')) {
		case "Y":
			define('__ADMINS_Y', " checked=\"checked\"");
			define('__ADMINS_N', "");
			break;

		case "N":
			define('__ADMINS_Y', "");
			define('__ADMINS_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_acls')) {
		case "Y":
			define('__ACLS_Y', " checked=\"checked\"");
			define('__ACLS_N', "");
			break;

		case "N":
			define('__ACLS_Y', "");
			define('__ACLS_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_exts')) {
		case "Y":
			define('__EXTS_Y', " checked=\"checked\"");
			define('__EXTS_N', "");
			break;

		case "N":
			define('__EXTS_Y', "");
			define('__EXTS_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_config')) {
		case "Y":
			define('__CONFIG_Y', " checked=\"checked\"");
			define('__CONFIG_N', "");
			break;

		case "N":
			define('__CONFIG_Y', "");
			define('__CONFIG_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_modreg')) {
		case "Y":
			define('__MODREG_Y', " checked=\"checked\"");
			define('__MODREG_N', "");
			break;

		case "N":
			define('__MODREG_Y', "");
			define('__MODREG_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_refdepth')) {
		case "Y":
			define('__REFDEPTH_Y', " checked=\"checked\"");
			define('__REFDEPTH_N', "");
			break;

		case "N":
			define('__REFDEPTH_Y', "");
			define('__REFDEPTH_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_refsys')) {
		case "Y":
			define('__REFSYS_Y', " checked=\"checked\"");
			define('__REFSYS_N', "");
			break;

		case "N":
			define('__REFSYS_Y', "");
			define('__REFSYS_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_themes')) {
		case "Y":
			define('__THEMES_Y', " checked=\"checked\"");
			define('__THEMES_N', "");
			break;

		case "N":
			define('__THEMES_Y', "");
			define('__THEMES_N', " checked=\"checked\"");
			break;
	}

	switch (getConfig('cache_admin_menu')) {
		case "Y":
			define('__ADMIN_MENU_Y', " checked=\"checked\"");
			define('__ADMIN_MENU_N', "");
			break;

		case "N":
			define('__ADMIN_MENU_Y', "");
			define('__ADMIN_MENU_N', " checked=\"checked\"");
			break;
	}

	define('__PATH', getConfig('cache_path'));

	// Load template
	LOAD_TEMPLATE("admin_config_cache");
}

//
?>
