<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/24/2004 *
 * ================                             Last change: 08/01/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_holiday.php                            *
 * -------------------------------------------------------------------- *
 * Short description : List all holiday requests                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Urlaubsschaltungen auflisten                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Start listing holiday requests
$result = SQL_QUERY("SELECT h.id, h.userid, h.holiday_start, h.holiday_end, h.comments, d.status, d.last_online
FROM "._MYSQL_PREFIX."_user_holidays AS h
LEFT JOIN `"._MYSQL_PREFIX."_user_data` AS d
ON h.userid=d.userid
ORDER BY h.userid", __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0)
{
	// List all holiday requests
	$SW = 2; $OUT = "";
	while (list($id, $uid, $start, $end, $comments, $status, $last) = SQL_FETCHROW($result))
	{
		// Add three dashes to comment when it is empty
		if (empty($comments)) $comments = "---";

		// Prepare data for the row template
		$content = array(
			'sw'       => $SW,
			'id'       => $id,
			'uid'      => ADMIN_USER_PROFILE_LINK($uid),
			'start'    => MAKE_DATETIME($start, "3"),
			'end'      => MAKE_DATETIME($end, "3"),
			'comments' => wordwrap($comments, 15),
			'status'   => TRANSLATE_STATUS($status),
			'last'     => MAKE_DATETIME($last, "3"),
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_list_holiday_row", true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	define('__HOLIDAY_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_list_holiday");
}
 else
{
	// No holiday requests found
	LOAD_TEMPLATE("admin_settings_saved", false, HOLIDAY_ADMIN_NOTHING_FOUND);
}
//
?>
