<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/12/2004 *
 * ================                             Last change: 11/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : action-themes.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Theme selector                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Theme-Auswahl                                    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif ((!EXT_IS_ACTIVE("theme")) && (!IS_ADMIN())) {
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "theme");
	return;
}

// Already loaded?
if (defined('__THEME_SELECTION_CONTENT')) return false;

// Load all active designs (or all if admin)
$whereStatement = ""; $OUT = "";
if (!IS_ADMIN()) $whereStatement = " WHERE theme_active='Y'";
$result_themes = SQL_QUERY("SELECT theme_path FROM `"._MYSQL_PREFIX."_themes`".$whereStatement, __FILE__, __LINE__);
$num_themes = SQL_NUMROWS($result_themes);

if ($num_themes > 1) {
	// If more than 1 is installed output selection box
	$act = "";
	if (!empty($GLOBALS['action'])) $act = SQL_ESCAPE($GLOBALS['action']);
	$OUT = THEME_SELECTION_BOX("index", $act, $GLOBALS['what'], $result_themes);
} elseif (($num_themes == 1) || ((!IS_ADMIN()) && ($num_themes == 0))) {
	// If there's only one just print it's name
	define('__THEME_NAME', GET_CURR_THEME_NAME());
	$OUT = LOAD_TEMPLATE("theme_one", true);
} elseif (IS_ADMIN()) {
	// If there is no theme installed and there's an admin notify him!
	$OUT = LOAD_TEMPLATE("admin_settings_saved", true, "<FONT class=\"admin_note\">".ADMIN_NO_THEME_INSTALLED_WARNING."</FONT>");
}

// Remember
define('__THEME_SELECTION_CONTENT', $OUT);

// Free memory
SQL_FREERESULT($result_themes);

// Load final box template
LOAD_TEMPLATE("theme_select_box");

//
?>
