<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/12/2008 *
 * ===============                              Last change: 12/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : pool-user.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Sends queued user mails from the pool            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet freigegebene Mitglieder-Mails aus Pool    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Don't run on daily reset
if (defined('__DAILY_RESET')) {
	// Skip here
	return false;
} elseif (!EXT_IS_ACTIVE("user")) {
	// Abort here if extension user is not active
	return false;
}

// Check for freed mail orders to send out
if (EXT_IS_ACTIVE("html_mail")) {
	//                                0     1        2      3       4          5            6      7        8          9       10
	$result_main = SQL_QUERY("SELECT id, sender, subject, text, receivers, payment_id, timestamp, url, target_send, cat_id, html_msg FROM "._MYSQL_PREFIX."_pool WHERE data_type='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
} else {
	//                                0     1        2      3       4          5            6      7        8          9    10
	$result_main = SQL_QUERY("SELECT id, sender, subject, text, receivers, payment_id, timestamp, url, target_send, cat_id, id FROM "._MYSQL_PREFIX."_pool WHERE data_type='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
}

// Reset variables
$cnt2 = 0; $LAST_SENT_ID = 0; $cnt_back = array("0"); $pointsBack = array("0");
if (SQL_NUMROWS($result_main) > 0) {
	// Parse all mails
	while ($DATA = SQL_FETCHROW($result_main)) {
		// Set mail order as "active". That means it will be sent out
		$result_active = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_pool SET data_type='ACTIVE' WHERE id=%s AND data_type='NEW' LIMIT 1",
			array($DATA[0]), __FILE__, __LINE__);

		// Check fetched data for HTML
		$HTML = $DATA[10]; if ($HTML == $DATA[0]) $HTML = "N";

		// Compile URL and subject line
		$DATA[7] = COMPILE_CODE($DATA[7]);

		// Entry updated?
		if (SQL_AFFECTEDROWS() == 1) {
			// "Explode" all receivers into an array
			if (ereg(";", $DATA[4])) {
				// There's more than one receiver in the list...
				$RECEIVERS = explode(";", $DATA[4]);
			} elseif (!empty($DATA[4])) {
				// Only one user left
				$RECEIVERS = array($DATA[4]);
			} else {
				// No users left
				$RECEIVERS = array("0");
			}
			$dummy = $RECEIVERS;

			// Now, if we are good little boys and girls Santa left us some user-ids.
			// We can now send mails to them...
			foreach ($RECEIVERS as $key => $uid) {
				// Lookup user ID
				$result_user = SQL_QUERY_ESC("SELECT gender, surname, family, email FROM `"._MYSQL_PREFIX."_user_data` WHERE userid=%s LIMIT 1",
					array(bigintval($uid)), __FILE__, __LINE__);

				// Is his data available?
				//* DEBUG: */ echo "*L:".__LINE__."/".SQL_NUMROWS($result_user)."*<br />";
				if (SQL_NUMROWS($result_user) == 1) {
					// The final receiver does exists so we can continue...
					list($gender, $sname, $fname, $email) = SQL_FETCHROW($result_user);

					// Free memory
					SQL_FREERESULT($result_user);

					// Do we have a stats entry?
					$result_stats = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_user_stats WHERE pool_id=%s AND userid=%s AND timestamp_ordered='%s' LIMIT 1",
						array($DATA[0], $DATA[1], $DATA[6]), __FILE__, __LINE__);

					// If there's no stats entry add it!
					//* DEBUG: */ echo "!L:".__LINE__."/".SQL_NUMROWS($result_stats)."!<br />";
					if (SQL_NUMROWS($result_stats) == 0) {
						// No entry was found, so we add him!
						$result_stats = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_user_stats (pool_id , userid, cat_id, payment_id, subject, url , max_rec , timestamp_ordered, timestamp_sstart) VALUES ('%s','%s','%s','%s','%s','%s','%s','%s' , UNIX_TIMESTAMP())",
							array(bigintval($DATA[0]), bigintval($DATA[1]), bigintval($DATA[9]), bigintval($DATA[5]), $DATA[2], $DATA[7], $DATA[8], bigintval($DATA[6])), __FILE__, __LINE__);

						// Receive it's ID for the links table
						$result_stats = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_user_stats WHERE pool_id=%s AND userid=%s AND timestamp_ordered='%s' LIMIT 1",
							array(bigintval($DATA[0]), bigintval($DATA[1]), bigintval($DATA[6])), __FILE__, __LINE__);
					} // END - if

					//* DEBUG: */ echo "!L:".__LINE__."/".SQL_NUMROWS($result_stats)."!<br />";
					if (SQL_NUMROWS($result_stats) == 1) {
						// We got one!
						list($stats_id) = SQL_FETCHROW($result_stats);

						// Mark this user as "spammed" ;-) And place a line for him...
						//* DEBUG: */ echo "?L:".__LINE__."/".$dummy."/".$key."/".$uid."(".$DATA[1].")/".$DATA[0]."/".$stats_id."?<br />";
						switch (REMOVE_RECEIVER($dummy, $key, bigintval($uid), bigintval($DATA[0]), bigintval($stats_id)))
						{
						case "done":
							// Prepare the mail
							$DATA[11] = bigintval($stats_id);
							$DATA[12] = $sname;
							$DATA[13] = $fname;
							$DATA[14] = TRANSLATE_GENDER($gender);

							// Replace text variables
							foreach ($REPLACER as $key => $value) {
								if (isset($DATA[$key])) $DATA[3] = str_replace($value, $DATA[$key], $DATA[3]);
							} // END - if

							// Prepare content
							$content = array(
								'id'         => $DATA[11],
								'url'        => $DATA[7],
								'sender_uid' => $DATA[1],
								'category'   => GET_CATEGORY($DATA[9]),
								'time'       => CREATE_FANCY_TIME(GET_PAY_POINTS($DATA[5], "time")),
								'points'     => TRANSLATE_COMMA(GET_PAY_POINTS($DATA[5], "payment")),
								'text'       => $DATA[3]
							);

							// Load message template
							$msg = LOAD_EMAIL_TEMPLATE("normal-mail", $content, bigintval($uid));

							// Send mail away
							SEND_EMAIL($email, $DATA[2], $msg, $HTML);

							// Count sent mails...
							$result = SQL_QUERY_ESC("UPDATE `"._MYSQL_PREFIX."_user_data` SET emails_sent=emails_sent+1 WHERE userid=%s LIMIT 1",
								array(bigintval($DATA[1])), __FILE__, __LINE__);

							if (GET_EXT_VERSION("user") >= "0.1.4") {
								// Update mails received for receiver
								$result = SQL_QUERY_ESC("UPDATE `"._MYSQL_PREFIX."_user_data` SET emails_received=emails_received+1 WHERE userid=%s LIMIT 1",
									array(bigintval($uid)), __FILE__, __LINE__);
							} // END - if

							// Update mediadata if version is 0.0.4 or higher
							if (GET_EXT_VERSION("mediadata") >= "0.0.4") {
								// Update entry (or add missing)
								//* DEBUG: */ echo "*MEDIA/L:".__LINE__."*<br />";
								MEDIA_UPDATE_ENTRY(array("total_send", "normal_send"), "add", 1);
							} // END - if

							// And count up the mail
							$cnt++;
							//* DEBUG: */ echo"*EXIT/L:".__LINE__."/".$cnt."*<br />";
							break;

						case "already":
							// Entry already found, but we still count one up!
							$cnt++;
							//* DEBUG: */ echo"*EXIT/L:".__LINE__."/".$cnt."<br />";
							break;
						}
					}

					// Do we have reached the maximum to send mails? || (getConfig('max_send') >= $cnt)
					//* DEBUG: */ echo "*L:".__LINE__."/".$cnt.">=".$DATA[8]."/".getConfig('max_send').">=".$cnt."/".$LAST_SENT_ID."!=".$DATA[0]."*<br />";
					if ((($cnt >= $DATA[8])) && ($LAST_SENT_ID != $DATA[0])) {
						// Prepare content
						$content = array(
							'sender_uid' => $DATA[1],
							'category'   => GET_CATEGORY($DATA[9]),
							'text'       => $DATA[3],
							'url'        => $DATA[7],
							'expiration' => CREATE_FANCY_TIME(GET_PAY_POINTS($DATA[5], "time"))
						);

						// Yes we do, so we notify admin and sender about fully sent mail!
						SEND_ADMIN_NOTIFICATION(ADMIN_SUBJ_SEND_DONE, "done-admin", $content, $uid);

						// Get sender's data
						$result_sender = SQL_QUERY_ESC("SELECT surname, family, email FROM `"._MYSQL_PREFIX."_user_data` WHERE userid=%s LIMIT 1",
							array(bigintval($DATA[1])), __FILE__, __LINE__);

						// Is the sender found?
						if (SQL_NUMROWS($result_sender) == 1) {
							// Load data and prepare mail
							list($sname, $fname, $email) = SQL_FETCHROW($result_sender);

							// Load email template
							$msg = LOAD_EMAIL_TEMPLATE("done-member", $content, $DATA[1]);

							// Send it also waway
							SEND_EMAIL($email, MEMBER_SUBJ_SEND_DONE, $msg);
						} // END - if

						// Free result
						SQL_FREERESULT($result_sender);

						// Set status to SEND because we completely send it away
						$result_done = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_pool SET data_type='SEND', target_send='0', receivers='' WHERE id=%s LIMIT 1",
							array(bigintval($DATA[0])), __FILE__, __LINE__);

						// Update send-completed-time
						$result_user = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_stats SET timestamp_send=UNIX_TIMESTAMP() WHERE pool_id=%s LIMIT 1",
							array(bigintval($DATA[0])), __FILE__, __LINE__);

						$LAST_SENT_ID = $DATA[0]; $cnt = 0;
						$cnt2 += $cnt;

						// Update mediadata if version is 0.0.4 or higher
						if (GET_EXT_VERSION("mediadata") >= "0.0.4") {
							// Update entry (or add missing)
							//* DEBUG: */ echo "*MEDIA/L:".__LINE__."*<br />";
							MEDIA_UPDATE_ENTRY(array("total_orders", "normal_orders"), "add", 1);
						} // END - if

						//* DEBUG: */ echo"*EXIT/L:".__LINE__."/".$P."<br />";
						break;
					}
					// Do we have send maximum mails?
					 elseif (($cnt >= getConfig('max_send')) || ($cnt2 >= getConfig('max_send'))) {
						// There are some mails left to send for next round, so we reset the status back to NEW (=still not fully delivered)
						$ADD = "";
						if ($cnt <= $DATA[8]) $ADD = ", target_send=target_send-".$cnt;
						$result_queue = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_pool SET data_type='NEW', receivers='%s'".$ADD." WHERE id=%s LIMIT 1",
						 array(implode(";", $dummy), bigintval($DATA[0])), __FILE__, __LINE__);

						//* DEBUG: */ echo"*EXIT/L:".__LINE__."*<br />";
						break;
					}

					// Free result
					SQL_FREERESULT($result_stats);
				} else {
					// User does not exists so we have add the sender's points back to sender's account
					if (($RECEIVERS[0] == "0") || (empty($RECEIVERS[0]))) {
						// List was empty
						$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_pool SET data_type='SEND' WHERE id=%s LIMIT 1",
						 array(bigintval($DATA[0])), __FILE__, __LINE__);
					} else {
						// Is the userid set?
						if ($uid > 0) {
							// User does not exists, pay points back
							$points = GET_PAY_POINTS($DATA[5]);
							ADD_POINTS_REFSYSTEM("pool_payback", $DATA[1], $points, false, "0", false, "direct");

							// Add points together and remove user
							$pointsBack[$DATA[1]] += $points;
						} // END - if

						// Count up
						$cnt_back[$DATA[1]]++;
					}

					// Remove entry from list
					unset($dummy[$key]);

					// Update receivers
					$result_queue = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_pool SET receivers='%s' WHERE id=%s LIMIT 1",
					 array(implode(";", $dummy), bigintval($DATA[0])), __FILE__, __LINE__);
				}
			}
		}
	}

	// Do we have points to "pay back"?
	if ((sizeof($pointsBack) > 0) && (!empty($pointsBack[0]))) {
		// Walk through all points
		foreach ($pointsBack as $uid => $PB) {
			// Add points only when we have points left to add and a valid user ID
			if (($PB > 0) && ($uid > 0)) {
				// Prepare content
				$content = array(
					'points' => TRANSLATE_COMMA($DATA[10])
				);

				// We have to pay back some points to the sender (we add them directly :-P)
				$result = SQL_QUERY_ESC("SELECT email FROM `"._MYSQL_PREFIX."_user_data` WHERE userid=%s AND status='CONFIRMED' LIMIT 1",
					array(bigintval($uid)), __FILE__, __LINE__);
				$DATA[10] = $PB; $DATA[11] = $cnt_back[$uid];

				// User found?
				if (SQL_NUMROWS($result) == 1) {
					list($email) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);

					// User account does exists, so we can safely pay back!
					$msg = LOAD_EMAIL_TEMPLATE("back-member", $content, bigintval($uid));

					// Send mail out to member
					SEND_EMAIL($email, MEMBER_BACK_JACKPOT." (".$uid.")", $msg);
				} else {
					// Add to jackpot
					ADD_JACKPOT($PB);

					// Send mail out to admin
					SEND_ADMIN_NOTIFICATION(ADMIN_BACK_JACKPOT." (".$uid.")", "back-admin", $content, "admin");
				}
			} // END - if
		} // END - foreach
	} // END - if
}

// Free memory
SQL_FREERESULT($result_main);

//
?>
